<template>
  <div class="profile">
    <VerificationModal
      v-if="showSmsVerificationModal"
      data-testid="sms-verification-modal"
      :phoneOrEmailToVerify="phoneInputInfo.e164"
      :verificationMethod="VERIFICATION_METHOD.SMS"
      :closeModal="toggleShowSmsVerificationModal"
      :onCloseSuccess="updateVerifiedPhoneInfo"
    />
    <deactivate-account-modal
      v-if="showDeactivateAccountModal"
      :closeModal="toggleDeactivatedAccountModal"
      :setIsAccountActive="setIsAccountActive"
    />
    <div class="header">
      Your profile
      <button
        type="button"
        class="editBtn btn"
        data-testid="edit-profile-btn"
        @click="editProfile()"
      >
        {{ editBtnMsg }}
      </button>
    </div>
    <div class="wrap-container">
      <div class="personal-info contain">
        <div v-if="errors.length" class="errors">
          <h4 class="errors-heading">
            Please correct the following problem
            <span v-if="errors.length > 1">s</span>
            before saving:
          </h4>
          <ul class="errors-list">
            <li v-for="error in errors" v-bind:key="error">{{ error }}</li>
          </ul>
        </div>
        <div v-if="saveFailed" class="errors">
          <h4 class="errors-heading">Could not save data</h4>
        </div>
        <div class="subheader">Personal Information</div>
        <div class="container-content">
          <div id="email" class="container-section">
            <div class="prompt">Your Email</div>
            <div id="ph-no-capture" class="answer">{{ user.email }}</div>
          </div>
          <div>
            <div id="phone" class="container-section">
              <div id="phone-heading">
                <div class="prompt">Your Phone Number</div>
                <button
                  v-if="user.phone && isStudent"
                  class="remove-phone-btn"
                  value="Remove"
                  @click="toggleDeletePhoneConfirmationModal"
                  data-testid="delete-phone-button"
                  id="delete-phone-button"
                  label="Remove"
                >
                  <TrashIcon id="delete-phone-icon" />
                  Remove
                </button>
              </div>
              <RemovePhoneConfirmationModal
                v-if="showDeletePhoneConfirmationModal"
                :onCancel="toggleDeletePhoneConfirmationModal"
                :onAccept="handleDeleteNumber"
              />
              <div
                id="ph-no-capture"
                v-show="!activeEdit && user.phone"
                class="answer phone-answer"
              >
                {{ phoneInputInfo.e164 }}

                <!-- Unverified phone number: Show alert with CTA to verify phone number -->
                <div
                  v-if="!this.user.phoneVerified"
                  class="alert alert-warning unverified"
                >
                  Your phone number has not been verified.
                  <span
                    class="uc-link secondary-btn"
                    @click.prevent="toggleShowSmsVerificationModal"
                    >Verify now
                  </span>
                </div>
              </div>

              <div v-show="!activeEdit && !user.phone" class="answer">
                No phone number provided
              </div>
              <maz-phone-number-input
                class="phone-input"
                required="true"
                v-show="activeEdit"
                v-model="phone"
                show-code-on-list
                @update="onPhoneInputUpdate"
                :country-code="showNationalPhoneNumbersOnly ? 'US' : null"
                :only-countries="showNationalPhoneNumbersOnly ? ['US'] : null"
                :no-search="showNationalPhoneNumbersOnly ? true : false"
              />

              <div class="sms-consent" v-if="shouldSeeSmsConsentCheckbox">
                <checkbox
                  id="sms-consent-checkbox"
                  :disabled="!activeEdit ? true : null"
                  v-model="smsConsent"
                  @change="emitSmsConsentCheckboxChangedEvent"
                  :checked="smsConsent"
                />
                <label for="sms-consent-input"
                  >By checking this box, I consent to receiving SMS messages
                  from UPchieve at the phone number provided above.</label
                >
              </div>
              <div class="description" v-if="isVolunteer">
                We will use this number to send you notifications when a student
                needs help. You will only receive notifications during the
                periods that you select in your schedule.
              </div>
            </div>
          </div>

          <div v-if="isVolunteer" class="container-section">
            <div class="prompt">Account status</div>
            <div class="answer">
              <toggle-button
                :disabled="!activeEdit ? true : null"
                :value="isAccountActive"
                :labels="{ checked: 'Active', unchecked: 'Deactivated' }"
                :width="95"
                :color="{
                  checked: '#16D2AA',
                  unchecked: '#F44747',
                  disabled: '#AAAAAA',
                }"
                @change="toggleAccountActive"
                :sync="true"
                data-testid="deactivate-account-toggle"
              />
            </div>
            <div class="description">
              Deactivate your account to stop receiving emails and text
              notifications. You can reactivate it at any time.
            </div>
          </div>

          <div
            v-if="isNotificationPermissionGranted && !isTeacher"
            class="container-section"
          >
            <div class="prompt">Browser Notifications</div>
            <div class="answer">
              <toggle-button
                :value="isAllowingNotifications"
                :labels="{ checked: 'On', unchecked: 'Off' }"
                :width="95"
                :color="{
                  checked: '#16D2AA',
                  unchecked: '#F44747',
                  disabled: '#AAAAAA',
                }"
                @change="toggleWebNotifications"
                :sync="true"
              />
            </div>
            <div v-if="isVolunteer" class="description">
              Browser alerts when a student appears on the dashboard waitlist
              and when a student sends a message while you're not looking.
            </div>
            <div v-else-if="isStudent" class="description">
              Browser alerts when a coach joins your session and when a coach
              sends a message while you're not looking.
            </div>
          </div>

          <hr v-if="isPartnerTeacher" />
          <div v-if="isPartnerTeacher" class="uc-column">
            <button class="sync-clever-btn" @click="syncClever">
              <clever-logo class="mr-2" />
              {{ user.lastSuccessfulCleverSync ? 'Resync' : 'Sync' }} Clever
            </button>
            <div class="last-clever-sync" v-if="user.lastSuccessfulCleverSync">
              Last successful Clever sync:
              {{ new Date(user.lastSuccessfulCleverSync).toLocaleString() }}
            </div>
          </div>

          <hr />

          <div class="uc-column">
            <router-link to="/resetpassword" class="resetBtn"
              >Reset password</router-link
            >
          </div>
        </div>
      </div>

      <div v-if="isVolunteer" class="cert-info contain">
        <div class="subheader-subjects">
          <div class="subheader-subjects--left">Unlocked Subjects</div>
          <div class="subheader-subjects--right" data-testid="tutoring-alerts">
            Tutoring Alerts
          </div>
        </div>
        <loader
          v-if="isFetchingSubjects"
          class="loader--center"
          :height="40"
          :width="40"
        />
        <div v-else class="container-content cert">
          <div
            v-for="subject in userSubjects"
            :key="`certification-${subject.name}-${subject.value}`"
          >
            <div v-if="subject.value" class="certBox">
              <div class="subjects-left">
                <div
                  :style="{
                    backgroundColor: subjects[subject.name].topicColor,
                  }"
                  class="certKey"
                >
                  {{ subjects[subject.name].topicDisplayName.toUpperCase() }}
                </div>
                <div class="certValue">
                  {{ subjects[subject.name].displayName }}
                </div>
              </div>
              <div class="subjects-right" data-testid="toggle-buttons">
                <toggle-button
                  :data-testid="`toggle-button-${subject.name}`"
                  :disabled="!activeEdit ? true : null"
                  :value="subjectIsNotMuted(subject.name)"
                  :width="75"
                  :labels="{ checked: 'On', unchecked: 'Off' }"
                  :color="{
                    checked: '#16D2AA',
                    unchecked: '#F44747',
                    disabled: '#AAAAAA',
                  }"
                  @change="
                    togglemutedSubjectAlerts(
                      subject.name,
                      subjectIsNotMuted(subject.name)
                    )
                  "
                  :sync="true"
                />
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters, mapState } from 'vuex'
import UserService from '@/services/UserService'
import AnalyticsService from '@/services/AnalyticsService'
import { Provider, signInWithSso } from '@/services/SsoService'
import DeactivateAccountModal from '../DeactivateAccountModal.vue'
import setNotificationPermission from '@/utils/set-notification-permission'
import getNotificationPermission from '@/utils/get-notification-permission'
import { EVENTS, VERIFICATION_METHOD } from '@/consts'
import Loader from '@/components/Loader.vue'
import VerificationModal from '../VerificationModal.vue'
import Checkbox from '@/components/CheckBox.vue'
import RemovePhoneConfirmationModal from '@/views/ProfileView/RemovePhoneConfirmationModal.vue'
import CleverLogo from '@/assets/clever_logo.svg'
import TrashIcon from '@/assets/trash.svg'
import ToggleButton from '@/components/ToggleButton.vue'
import MazPhoneNumberInput from 'maz-ui/components/MazPhoneNumberInput'

export default {
  name: 'profile-view',
  components: {
    RemovePhoneConfirmationModal,
    Checkbox,
    DeactivateAccountModal,
    MazPhoneNumberInput,
    Loader,
    VerificationModal,
    TrashIcon,
    CleverLogo,
    ToggleButton,
  },
  data() {
    return {
      activeEdit: false,
      editBtnMsg: 'Edit',
      errors: [],
      invalidInputs: [],
      saveFailed: false,
      phone: '',
      phoneInputInfo: {},
      isAccountActive: true,
      isAllowingNotifications: true,
      showDeactivateAccountModal: false,
      shouldSeeSmsConsentCheckbox: false,
      showDeletePhoneConfirmationModal: false,
      showSmsVerificationModal: false,
      smsConsent: false,
      newMutedSubjectAlerts: [],
    }
  },
  created() {
    this.isAllowingNotifications = getNotificationPermission() === 'granted'
    this.isAccountActive = !this.user.isDeactivated
    if (this.user.phone) {
      this.phone = this.user.phone
      this.smsConsent = this.user.smsConsent
    }
    if (this.isVolunteer) {
      this.newMutedSubjectAlerts = [...this.user.mutedSubjectAlerts]
    }
    this.setFlagsForEditingPhoneNumber()
  },
  computed: {
    ...mapState({
      user: (state) => state.user.user,
      subjects: (state) => state.subjects.subjects,
      isFetchingSubjects: (state) => state.subjects.isFetchingSubjects,
    }),
    ...mapGetters({
      userType: 'user/userType',
      isVolunteer: 'user/isVolunteer',
      isStudent: 'user/isStudent',
      isTeacher: 'user/isTeacher',
      showNationalPhoneNumbersOnly: 'user/showNationalPhoneNumbersOnly',
      allSubtopics: 'subjects/allSubtopics',
      isFilterActiveSubjectsActive: 'featureFlags/isFilterActiveSubjectsActive',
    }),
    isPartnerTeacher() {
      return this.isTeacher && this.user.isSchoolPartner
    },
    name() {
      const user = this.$store.state.user.user
      return user.firstname || this.userType
    },
    VERIFICATION_METHOD() {
      return VERIFICATION_METHOD
    },
    userSubjects() {
      const user = this.$store.state.user.user
      const userSubjects = this.isFilterActiveSubjectsActive
        ? user.activeSubjects
        : user.subjects

      const subjects = this.$store.state.subjects.subjects

      const sortedSubjects = userSubjects
        .map((subject) => {
          const displayName = subjects[subject].displayName
          return {
            name: subject,
            value: true,
            displayName: displayName,
          }
        })
        .sort((a, b) => a.displayName.localeCompare(b.displayName))

      return sortedSubjects
    },
    isNotificationPermissionGranted() {
      return 'Notification' in window && Notification.permission === 'granted'
    },
    userNeedsToVerifyPhone() {
      return (
        this.user.phone !== this.phoneInputInfo.e164 ||
        (this.user.phone && !this.user.phoneVerified)
      )
    },
  },
  methods: {
    onPhoneInputUpdate(phoneInputInfo) {
      this.phoneInputInfo = phoneInputInfo
    },
    toggleDeletePhoneConfirmationModal() {
      this.showDeletePhoneConfirmationModal =
        !this.showDeletePhoneConfirmationModal
    },
    handleDeleteNumber() {
      this.showDeletePhoneConfirmationModal = false
      this.shouldSeeSmsConsentCheckbox = false
      this.smsConsent = false
    },

    async emitSmsConsentCheckboxChangedEvent() {
      AnalyticsService.captureEvent(EVENTS.SMS_CONSENT_CHECKBOX_CHANGED, {
        event: EVENTS.SMS_CONSENT_CHECKBOX_CHANGED,
        value: this.smsConsent ? 'checked' : 'unchecked',
      })
    },

    toggleAccountActive({ value }) {
      if (!value) {
        this.toggleDeactivatedAccountModal()
        return
      }
      this.setIsAccountActive(true)
    },

    toggleDeactivatedAccountModal() {
      this.showDeactivateAccountModal = !this.showDeactivateAccountModal
    },

    toggleWebNotifications({ value }) {
      const permission = value ? 'granted' : 'denied'
      this.isAllowingNotifications = value
      setNotificationPermission(permission)
    },

    togglemutedSubjectAlerts(subject, isNotMuted) {
      if (isNotMuted) {
        this.newMutedSubjectAlerts.push(subject)
      } else {
        this.newMutedSubjectAlerts = this.newMutedSubjectAlerts.filter(
          (s) => s != subject
        )
      }
    },

    subjectIsNotMuted(subject) {
      return !this.newMutedSubjectAlerts.includes(subject)
    },

    toggleShowSmsVerificationModal() {
      this.showSmsVerificationModal = !this.showSmsVerificationModal
    },

    setIsAccountActive(value) {
      this.isAccountActive = value
    },

    async updateVerifiedPhoneInfo() {
      this.shouldSeeSmsConsentCheckbox = this.isStudent
    },

    syncClever() {
      signInWithSso({
        provider: Provider.CLEVER,
        email: this.user.email,
      })
    },

    /**
     * Toggle editing state.
     * {Case A} if activeEdit === false: enter the editing state by setting activeEdit to true
     * {Case B} if activeEdit === true: save profile changes & exit the editing state by setting activeEdit to false
     */
    editProfile() {
      // {Case A} Enter the editing state, then early exit
      if (!this.activeEdit) {
        this.editBtnMsg = 'Save'
        this.activeEdit = true
        return
      }

      // {Case B} The remainder of this function saves new changes and exits the editing state

      // Start by erasing previous errors
      this.errors = []
      this.invalidInputs = []
      this.saveFailed = false

      // Validate fields
      if (this.isVolunteer) {
        // volunteers must provide a phone number, so display error message and
        // mark field invalid
        if (
          this.user.phone &&
          (!this.phoneInputInfo.isValid || !this.phoneInputInfo.e164)
        ) {
          this.errors.push('Please enter a valid phone number.')
          this.invalidInputs.push('phone')
        }
      }

      if (!this.errors.length) {
        const isDeactivatedBeforeUpdate = this.user.isDeactivated
        const reqBody = this.createUpdateProfileRequestBody()

        // wait for save to succeed before coming out of edit mode
        UserService.setProfile(reqBody).then(
          () => {
            this.editBtnMsg = 'Edit'
            this.activeEdit = false
            this.saveFailed = false

            AnalyticsService.captureEvent(EVENTS.PROFILE_UPDATED, {
              event: EVENTS.PROFILE_UPDATED,
            })

            if (
              reqBody.isDeactivated &&
              reqBody.isDeactivated !== isDeactivatedBeforeUpdate
            )
              AnalyticsService.captureEvent(EVENTS.ACCOUNT_DEACTIVATED, {
                event: EVENTS.ACCOUNT_DEACTIVATED,
              })

            if ('smsConsent' in reqBody) {
              const evt = reqBody.smsConsent
                ? EVENTS.SMS_OPTED_IN
                : EVENTS.SMS_OPTED_OUT
              AnalyticsService.captureEvent(evt, {
                event: evt,
              })
            }

            // Update user state after successful API call
            let addToUserData = {
              phone: reqBody.phone ?? this.user.phone,
              isDeactivated: reqBody.isDeactivated ?? !this.isAccountActive,
              smsConsent: reqBody.smsConsent ?? this.user.smsConsent,
            }
            if (this.isVolunteer) {
              addToUserData.mutedSubjectAlerts =
                reqBody.mutedSubjectAlerts ?? this.user.mutedSubjectAlerts
            }
            this.$store.dispatch('user/addToUser', addToUserData).then(() => {
              // Phone number verification flow
              if (this.userNeedsToVerifyPhone) {
                this.showSmsVerificationModal = true
              }
            })
          },
          () => {
            this.saveFailed = true
          }
        )
      }
    },

    createUpdateProfileRequestBody() {
      const reqBody = {}
      reqBody.isDeactivated = !this.isAccountActive

      // Students get a checkbox to opt in/out of SMS
      if (this.isStudent && this.smsConsent !== this.user.smsConsent) {
        reqBody.smsConsent = this.smsConsent
      }

      if (this.isVolunteer) {
        reqBody.mutedSubjectAlerts = this.newMutedSubjectAlerts
      }
      return reqBody
    },

    setFlagsForEditingPhoneNumber() {
      this.shouldSeeSmsConsentCheckbox = this.isStudent && this.user.phone
    },
  },
}
</script>

<style lang="scss" scoped>
.profile {
  font-size: 16px;
  font-family: $font-family-default;
}

.wrap-container {
  padding: 15px 15px 55px 15px;
  @include flex-container(column);
  align-items: stretch;

  @include child-spacing(top, 16px);
  @include child-spacing(right, 0);

  @include breakpoint-above('large') {
    padding: 40px;

    @include child-spacing(top, 0);
    @include child-spacing(right, 40px);

    @include flex-container(row);

    & > * {
      flex-basis: 50%;
    }
  }
}

.header {
  display: flex;
  margin: 0;
  font-size: 24px;
  align-items: center;
  justify-content: space-between;
  font-weight: 500;
  padding: 25px 15px 10px 35px;

  @include breakpoint-above('large') {
    padding: 40px 40px 0 40px;
  }
}

.contain {
  display: flex;
  flex-direction: column;
  border-radius: 8px;
  background: #fff;
}

.container-content {
  padding: 20px;
  text-align: left;

  @include breakpoint-above('large') {
    padding: 40px;
  }
}

.subheader {
  font-weight: 600;
  display: flex;
  justify-content: center;
  align-items: center;
  padding: 30px 15px 0;
  font-size: 20px;
}

.subheader-subjects {
  display: grid;
  grid-template-columns: 2fr 1fr;
  grid-template-rows: 1;
  font-size: 20px;
  font-weight: 600;
  padding: 30px 15px 0;
}

.subheader-subjects--center {
  grid-column: 1 / 3;
  text-align: center;
}

.subheader-subjects--left {
  grid-column: 1;
  text-align: left;
}

.subheader-subjects--right {
  grid-column: 2;
  text-align: right;
}

.subjects-left {
  grid-column: 1;
  text-align: left;
}

.subjects-right {
  grid-column: 2;
  text-align: right;
  padding-top: 8px;
}

.container-section {
  display: flex;
  flex-direction: column;
  margin-bottom: 20px;
}

ul {
  padding: 0px;
  height: 100%;
  margin: auto;
}

.basic-info {
  display: flex;
  flex-direction: column;
  align-items: left;
  margin-top: 30px;
}

.info-header {
  display: flex;
  align-items: center;

  margin-left: 30px;
  font-size: 20px;
  font-weight: 600;
}

.info-header.basic {
  height: 60px;
}

.info-header.cert {
  margin-bottom: 15px;
}

.answer {
  font-weight: 600;
}

#phone-heading {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
}

.phone-answer {
  display: flex;
  flex-direction: column;
  gap: 8px;
  align-items: baseline;
}

.answer .vue-js-switch {
  margin: 5px 0;
}

.answer ul {
  margin-left: 20px;
}

.phone-input {
  margin: 5px 0 0;
}

.description {
  margin-top: 10px;
  font-size: 12px;
}

button {
  height: 30px;
  border-radius: 20px;
  padding: 0px 10px;
  color: #16d2aa;
  background-color: #f6f6f6;
}

button:active,
button:hover {
  background-color: #16d2aa;
  color: #fff;
}

.editBtn {
  background-color: #16d2aa;
  border-radius: 30px;
  width: 120px;
  align-items: center;
  height: 40px;
  justify-content: center;
  font-size: 16px;
  font-weight: 600;
  color: white;

  &:hover {
    color: #2c3e50;
  }
}

.form-control {
  border: none;
  box-shadow: none;
  border-radius: 0;
  background-color: #f0f8fd;
}

.form-control {
  border-bottom: 3px solid #16d2aa;
  margin-bottom: 10px;

  &.invalid {
    border-bottom: 3px solid #bf0000;
  }
}

.form-control:focus {
  border-bottom: 3px solid #16d2aa;
  box-shadow: none;
}

.resetBtn {
  border: 1px solid $c-error-red;
  border-radius: 20px;
  color: darken($c-error-red, 25%);
  padding: 10px 20px;
  width: fit-content;

  &:hover {
    background-color: lighten($c-error-red, 30%);
    text-decoration: none;
  }
}

.remove-phone-btn {
  color: $c-soft-black;
  border-radius: 0px;
  border: none;
  background-color: transparent;
  display: flex;
  flex-direction: row;
  align-items: baseline;
  gap: 4px;

  &:hover {
    background-color: transparent;
    color: $c-soft-black;
  }

  button {
    border: none;
    background: none;
    padding-left: 0px;
  }

  #delete-phone-icon {
    height: 14px;
    width: 14px;
  }
}

.container-content.cert {
  padding: 30px 0 0;
}

.certBox {
  display: grid;
  grid-template-columns: 2fr 1fr;
  grid-template-rows: 1;
  height: 60px;
  align-items: center;
  padding-left: 20px;
  padding-right: 20px;
  border-top: 1px solid #cccccf;
  font-weight: 600;
}

.certKey {
  display: inline-block;
  border-radius: 12px;
  padding: 0 10px;
  margin: 0 10px 0 0;
  color: #ffffff;
  font-size: 12px;
  background-color: #1855d1;
}

.certValue {
  display: inline-block;
}

.errors {
  text-align: left;
  padding: 30px;
}

.errors-heading {
  color: #bf0000;
}

.errors-list {
  color: #bf0000;
  margin-left: 40px;
}

.loader--center {
  margin-top: 2em;
  margin-right: auto;
  margin-left: auto;
}

.unverified {
  display: flex;
  flex-direction: row;
  gap: 4px;
  font-weight: normal;
  g {
    fill: $c-warning-orange;
  }
}

.secondary-btn {
  &:hover {
    cursor: pointer;
  }

  p {
    font-style: none;
  }
}

.sms-consent {
  display: flex;
  align-items: baseline;
}

.sync-clever-btn {
  background-color: $upchieve-white;
  color: $c-information-blue;
  height: fit-content;
  padding: 10px 20px 10px 0;
  width: fit-content;

  &:hover {
    background-color: $upchieve-white;
    color: $c-information-blue;
    text-decoration: underline;
  }
}

.last-clever-sync {
  color: $c-secondary-grey;
  font-size: 14px;
}
</style>
